-- RuneCraft 0.43b in fact
-- Author: Ganjaaa

local Sol = LibStub("Sol");

local DebugMode = false;
local DBLoaded = false;
local AktTier = 0;

local MaxScroll = 6;
local Runes = nil
local MaxTier = 11

-- OnLoad
function RCMain_OnLoad(this)
	this:RegisterEvent("VARIABLES_LOADED");
	RC_DBLoad();
	-- Tier Name Set
	for i = 1,MaxTier do
		getglobal("RCMain_Tier"..i.."_Titel"):SetText(RCText.Menu.Tier1..(i-1)..RCText.Menu.Tier2);
	end
	-- Tier Layer
	getglobal("RCMain_Tier"):SetText(RCText.Menu.Tier1.."0"..RCText.Menu.Tier2);
	-- Needed Layer
	getglobal("RCMain_Needed"):SetText(RCText.Menu.Needed);
	if DebugMode then RCMain:Show() end;
end
-- OnEvent
function RCMain_OnEvent(this,event)
	if event == "VARIABLES_LOADED" then
		RC_SetScroll(0,1);
		RC_SetPrev(11);
		if ( AddonManager ) then
			local addon = {
				name = "RuneCraft",
				version = "v0.43d",
				author = "Felix K. aka Ganjaaa",
				description = "Its a combination Guid for Runes",
				icon = "Interface/AddOns/RuneCraft/Gfx/RuneCraftIcon.tga",
				category = "Information",
				slashCommands = "/rc",
				configFrame = RCMain,
				onClickScript = RCMain_Show
			}
			RCMain_Title:SetText(string.format("%s %s", addon.name, addon.version))
			if AddonManager.RegisterAddonTable then
				AddonManager.RegisterAddonTable(addon);
			else
				AddonManager.RegisterAddon(addon.name,addon.description);
			end
		else
			RC_Print(RCText.PrintOut.Say1);
			RC_Print(RCText.PrintOut.Say2);
		end
		RC_TreeClear();
	end
end
-- OnClick
function RCList_OnClick(this)
	if RC_InArray(Runes,getglobal(this:GetName().."_Name"):GetText()) then
		RC_SetPrev(RC_InArray(Runes,getglobal(this:GetName().."_Name"):GetText()));
	end
end
-- Tooltip
function RCGrade_Tooltip(this)
	if RC_InArray(Runes,getglobal("RCPrev_Icon_Name"):GetText()) then
		local id = RC_InArray(Runes,getglobal("RCPrev_Icon_Name"):GetText());
		if Runes[id].ID ~= "" then
			local itemid = string.format("%X", tonumber(Runes[id].ID, 16) + this:GetID()-1)
			local link = RC_StringToLink(Runes[id].Name.." "..RC_Num2Rom(this:GetID()),itemid);
			RCTooltip:SetHyperLink(link);
			RCTooltip:Show();
		end
	end
end
function RCTooltip_Set(this)
	if RC_InArray(Runes,getglobal(this:GetName().."_Name"):GetText()) then
		local id = RC_InArray(Runes,getglobal(this:GetName().."_Name"):GetText())
		if Runes[id].ID ~= "" then
			RCTooltip:SetHyperLink(RC_StringToLink(Runes[id].Name, Runes[id].ID));
			RCTooltip:Show();
		end
	end
end

function RCGrade_Click(this)
	if RC_InArray(Runes,getglobal("RCPrev_Icon_Name"):GetText()) then
		local id = RC_InArray(Runes,getglobal("RCPrev_Icon_Name"):GetText());
		if Runes[id].ID ~= "" then
			local itemid = string.format("%X", tonumber(Runes[id].ID,16) + this:GetID()-1)
			local link = RC_StringToLink(Runes[id].Name.." "..RC_Num2Rom(this:GetID()),itemid);
			ChatEdit_AddItemLink(link)
		end
	end
end

-- Interne Funktionen
-- Erstellt BaumArray
function RC_Tree(start,id,ids)
	local baum = {};
	if start ~= 0 then
		if Runes[id].Type ~= 0 then
			baum[1] = Runes[id].Name;
			baum[2] = RC_Tree(0,Runes[id].Comb[1],Runes[id].Comb[2]);
		else
			baum[1] = Runes[id].Name;
			baum[2] = 0;
		end
	elseif id ~= 0 then
		if Runes[id].Type ~= 0 then
			baum[1] = Runes[id].Name;
			baum[2] = RC_Tree(0,Runes[id].Comb[1],Runes[id].Comb[2]);
			baum[3] = Runes[ids].Name;
			baum[4] = RC_Tree(0,Runes[ids].Comb[1],Runes[ids].Comb[2]);
		else
			baum[1] = Runes[id].Name;
			baum[2] = 0;
			baum[3] = Runes[ids].Name;
			baum[4] = 0;
		end
	else
		baum[1], baum[2], baum[3], baum[4] = 0,0,0,0
	end
	return baum;
end

function RC_TreeList(this)
	local id = RC_InArray(Runes,getglobal(this:GetName().."_Name"):GetText());
	local tree = RC_Tree(1,id,id);
	RC_TreeClear();
	RC_TreeFollow(tree,1);
end

function RC_TreeFollow(tbl,space)
	for k, v in pairs(tbl) do
		if type(v) ~= "table" then
			if v ~= 0 then
				RC_AddLine(tostring(v));
			end
		end
	end
	for k, v in pairs(tbl) do
		if type(v) == "table" then
			RC_TreeFollow(v,space+1);
		end
	end
end

function RC_AddLine(str)
	if str ~= "--------------------" then
		local id = RC_InArray(Runes,str);
		for i=1,19,1 do
			if getglobal("RCTree_Line"..i):GetText() == "" then
				if Runes[id].Type == 0 or Runes[id].Comb[1] == 0 then
					getglobal("RCTree_Line"..i):SetText(Runes[id].Name); 
				else
					getglobal("RCTree_Line"..i):SetText(Runes[id].Name.."="..Runes[Runes[id].Comb[1]].Name.."+"..Runes[Runes[id].Comb[2]].Name); 
				end
				break;
			end		
		end
	else
		for i=1,19,1 do
			if getglobal("RCTree_Line"..i):GetText() == "" then
				getglobal("RCTree_Line"..i):SetText(str); 
				break;
			end		
		end
	end
end

function RC_TreeClear()
	for i=1,19,1 do
		if i==2 or i==5 or i== 10 or i==19 then
			getglobal("RCTree_Line"..i):SetText("--------------------");
		else
			getglobal("RCTree_Line"..i):SetText("");
		end;
	end
end

---- Setzt Preview
function RC_SetPrev(id)
	RC_SetIconTemplate("RCPrev_Icon",Runes[id].Name,Runes[id].Icon);
	for i=1,10,1 do
		local gtext = RCText.Menu.Grade..i.." : ";
		if Runes[id].ID ~= "" then
			gtext = gtext..RC_StringToLink(Runes[id].Name.." "..RC_Num2Rom(i), string.format("%X", tonumber(Runes[id].ID,16)+i-1));
		end
		getglobal("RCPrev_Grade"..i.."_Name"):SetText(gtext);
	end
	if Runes[id].Comb[1] ~= 0 then
		RC_SetIconTemplate("RCPrev_Need1",Runes[Runes[id].Comb[1]].Name,Runes[Runes[id].Comb[1]].Icon);
		RC_SetIconTemplate("RCPrev_Need2",Runes[Runes[id].Comb[2]].Name,Runes[Runes[id].Comb[2]].Icon);
	else
		RC_SetIconTemplate("RCPrev_Need1",RCText.Runes.Empty,"");
		RC_SetIconTemplate("RCPrev_Need2",RCText.Runes.Empty,"");
	end
end
---- Holt oder setzt Tier
function RC_AktTier(tier)
	if tier == nil then
		return AktTier;
	else
		getglobal("RCMain_Tier"):SetText(RCText.Menu.Tier1..tier..RCText.Menu.Tier2);
		AktTier = tier;
		return AktTier;
	end;
end
---- Bilded Itemlink aus Name und ID
function RC_StringToLink(name, id)
	local s = "";
	s = "|Hitem:"..id..":1:0:0:0:0:0:0:0:0:0:0|h|cffffffff["..name.."]|r|h";
	return s;
end
---- Sucht in Array
function RC_InArray(array,value)
	local s = false;
	for ix, var in pairs(array) do
		if var.Name == value then
			s = ix;
			break;
		end
	end
	return s;
end
---- Setzt Scrollbar
function RC_SetScroll(tier,start)
	local Items={};
	local count=0
	for index,value in pairs(Runes) do
		if value.Type == tier then
			count=count+1;
			Items[count] = value;
		end
	end
	if (count-MaxScroll) > 0 then
		RCMain_Slider:SetMinMaxValues(1,count-MaxScroll+1,1);	
	else
		RCMain_Slider:SetMinMaxValues(1,1,1);	
	end
	if count >= 6 then
		for i = 1,MaxScroll,1 do
			RC_SetIconTemplate("RCList_Item"..i,Items[start+i-1].Name,Items[start+i-1].Icon);
		end
	else
		for i=1,count,1 do
			RC_SetIconTemplate("RCList_Item"..i,Items[start+i-1].Name,Items[start+i-1].Icon);
		end
		for i=count+1,6,1 do
			RC_SetIconTemplate("RCList_Item"..i,"","");
		end
	end
end
---- Belegt Icon Text Templates
function RC_SetIconTemplate(name,text,img)
	getglobal(name.."_Name"):SetText(text);
	getglobal(name.."_Icon"):GetNormalTexture():SetFile("interface\\icons\\"..img);	
	getglobal(name.."_Icon"):GetPushedTexture():SetFile("interface\\icons\\"..img);	
end

-- set the correct system names
local RC_RunesDB = {}
local function ProcessRunes()
	Runes = RCRunes
	for _,rune in pairs(Runes) do
		local name = TEXT('Sys' .. rune.id .. '_name')
		if name then
			rune.Name = name:sub(1, name:len()-2)
		end
		RC_RunesDB[rune.id] = rune
	end
end

-- public function
function RC_GetRune(id)
	if type(id) == 'string' then
		id = tonumber(id, 16)
	end
	if not id or id < 520000 or id > 530000 then
		return nil
	end
	-- first rune id
	local fid = math.floor( (id-1) / 10)*10 + 1
	if RC_RunesDB[fid] then
		local rune = RC_RunesDB[fid]
		return rune, rune.Type, id-fid+1
	end
	return nil
end

---- Bentigte DBs hinzuladen
function RC_DBLoad()
	if not DBLoaded then
		local loc = GetLanguage();
		RC_LoadFile("Interface\\AddOns\\RuneCraft\\DB\\EQ_Runes.lua");
	  DBLoaded = RC_LoadFile("Interface\\AddOns\\RuneCraft\\Lang\\" .. loc .. "_Lang.lua");
	  if not DBLoaded then
			RC_LoadFile("Interface\\AddOns\\RuneCraft\\Lang\\ENEU_Lang.lua");
			DBLoaded = true;
		end
		ProcessRunes()
	end
end
---- Dezimal zu Rmisch
function RC_Num2Rom(num)
	local tmp = {"I","II","III","IV","V","VI","VII","VIII","IX","X"};
	if num <= 10 and num > 0 then
		return tmp[num];
	elseif num > 10 and num <= 20 then
		return 'X'..tmp[num];
	end
	return "XXX";
end
---- Ld eine Datei Hinzu
function RC_LoadFile(str)
	local func, err = loadfile(str);
	if (err) then
		return false, err;
	end
	dofile(str);
	return true;
end
---- ffnet/Schliet Menu
function RCMain_Show()
	if (RCMain:IsVisible()) then
		RCMain:Hide();
		RCTree:Hide();
	else
		RCMain:Show();
		RCTree:Show();
	end
end
---- PrintOut
function RC_Print(str)
	Sol.io.Print("[RuneCraft]: |cf00ff00 "..str);
end

---- Debug Say
function DebugMessage(str)
	if DebugMode then
		Sol.io.Print("[RCDebug]: |cffff0000"..str);
	end
end

SLASH_RUNECRAFT1 = "/rc"
SlashCmdList["RUNECRAFT"] = RCMain_Show



--[[
berprfung der ein inventar gegenstnde auf runen
abspeicher der einzelenenn vorhanden daten aktualliserien bei aitem algen oder update

berorpfung der namen auf ranke -> nutzung tooltops

nehemn tier und kontrollieren nach ranke -> mehrdimen array 

einbzeige alle baubaren runen fr jeden rank einzeln]]--